#!/bin/bash

if [ $# != 4 ] ; then 
  echo "Usage: ./testClassifier.sh folder/file_name classifier_type output_filename type(-a:all -test:100 -single:1)" 1>&2
  exit 1
fi

folder_name=$1
classifier_type=$2
output=$3
i=0
j=0
case "$4" in
	-all)
		#Runs javaImageClassifier on ALL images
		for file_name in $folder_name/*/*.png; do
			echo $file_name
			echo $output
			echo $i
			echo ""
			java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaImageClassifier $file_name $classifier_type $output
			i=$[$i+1]
		done
	;;
		
	-test)
		#Runs javaImageClassifier on 100 images of each
		for file_name in $folder_name/SheetMusic/*.png; do
			if [ $i -lt 10 ] ; then
				echo $file_name
				echo $output
				echo $i
				echo ""
				java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaImageClassifier $file_name $classifier_type $output
				i=$[$i+1]		
			fi
		done
		for file_name in $folder_name/NotSheetMusic/*.png; do
			if [ $j -lt 10 ] ; then
				echo $file_name
				echo $output
				echo $j
				echo ""
				java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaImageClassifier $file_name $classifier_type $output
				j=$[$j+1]		
			fi
		done
	;;
	-single)
		#Runs javaImagesClassifier on ONE image
		javac -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar javaImageClassifier.java;
		echo $file_name
		echo $output
		echo $classifier_type
		java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaImageClassifier $file_name $classifier_type $output

			
esac		
